SystemOrganization addCategory: #'Sheet-Magritte'!

WAObject subclass: #ShSpreadsheet
	instanceVariableNames: 'fileName data dataDescription author sheetName useHeader splitLeft splitTop'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

!ShSpreadsheet class methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2014 01:17'!
builder

	^ (WABuilder on: ShSpreadsheetCanvas)
			rootClass: ShSpreadsheetRoot;
			documentClass: WAXmlDocument;
			yourself! !

!ShSpreadsheet class methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 10:01'!
contentType

	^ WAMimeType main: 'application' sub: 'xml'! !

!ShSpreadsheet class methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 14:43'!
isBinary 

	^ false! !

!ShSpreadsheet class methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 15:40'!
printDate: aDateAndTime

	^ String streamContents: [:stream |
		GRPrinter isoDate print: aDateAndTime on: stream.
		stream nextPut: $T.
		GRPrinter isoTime print: aDateAndTime on: stream.
		stream nextPut: $Z]  
	! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:34'!
author
	"Answer the value of author"

	^ author! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:34'!
author: anObject
	"Set the value of author"

	author := anObject! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:32'!
data
	"Answer the value of data"

	^ data! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:32'!
data: anObject
	"Set the value of data"

	data := anObject! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:32'!
dataDescription
	"Answer the value of dataDescription"

	^ dataDescription! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:32'!
dataDescription: anObject
	"Set the value of dataDescription"

	dataDescription := anObject! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:37'!
fileName
	"Answer the value of fileName"

	^ fileName! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:37'!
fileName: anObject
	"Set the value of fileName"

	fileName := anObject! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 17:20'!
renderContentOn: sheet

	sheet workbook 		
		with: [ self 
			renderPropertiesOn: sheet;
			renderWorkBookOn: sheet;
			renderStylesOn: sheet;
			renderSheetsOn: sheet]			! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2014 01:21'!
renderHeaderOn: sheet

	ShColumnWriter visit: self dataDescription withSheet: sheet.
	sheet row: [
		ShFirstLineWriter visit: self dataDescription withSheet: sheet]! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 10:34'!
renderPropertiesOn: sheet

	sheet documentProperties: [
		sheet 
			author: self author;
			created: (self class printDate:  DateAndTime now);
			version: '12.00'] ! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2014 01:20'!
renderRowsOn: sheet

	self data do: [:datum |
		sheet row: [
			ShSpreadsheetDataWriter write: datum to: sheet]]! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 10:38'!
renderSheetOn: sheet

	sheet worksheet 
		name: self sheetName;
		with: [
			self
				renderTableOn: sheet;
				renderSheetOptionsOn: sheet]! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 10:58'!
renderSheetOptionsOn: sheet

	| topRows leftRows |
	topRows := (self splitTop ifNil: [0]) + ((self useHeader) ifTrue: [1] ifFalse: [0]).
	leftRows := self splitLeft ifNil: [0].    
	sheet worksheetOptions: [
		sheet 
			selected;
			freezePanes;
			frozenNoSplit;
			splitHorizontal: [sheet text: topRows];
			topRowBottomPane: [sheet text: topRows];
			splitVertical: [sheet text: leftRows];
			leftColumnRightPane: [sheet text: leftRows];
			panes: [
				0 to: ((((topRows > 0) ifFalse: [0] ifTrue: [2]) + ((leftRows > 0) ifFalse: [0] ifTrue: [2])) -1) do: [:paneNum |
					sheet pane: [sheet number: [sheet text: paneNum]]]];
			protectObjects: [sheet text: 'False'];
			protectScenarios:  [sheet text: 'False']]! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 17:09'!
renderSheetsOn: xml

	self renderSheetOn: xml.! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 20:33'!
renderStylesOn: sheet

	sheet styles: [].! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2014 01:21'!
renderTableOn: sheet

	| rows cols |
	rows := self data size + (self useHeader ifTrue: [1] ifFalse: [0]).
	cols := ShColumnCounter visit: self dataDescription.
	sheet table
		fullColumns: 1;
		fullRows: 1;   
		expandedRowCount: rows;
		expandedColumnCount: cols;  	
		with: [
			self 
				renderHeaderOn: sheet;
				renderRowsOn: sheet]
	! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 10:28'!
renderWorkBookOn: sheet

	sheet excelWorkbook: [
		(sheet tag: 'WindowHeight') with: '6795'.
		(sheet tag: 'WindowWidth') with: '8460'.
		(sheet tag: 'WindowTopX') with: '120'.
		(sheet tag: 'WindowTopY') with: '15'.
		(sheet tag: 'NoAutorRecover').
		(sheet tag: 'ProtectStructure') with: 'False'.
		(sheet tag: 'ProtectWindows') with: 'False']! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 14:36'!
renderedContent

	^ self class builder
		fullDocument: true;
		rootBlock: [ :root | self updateRoot: root ];
		render: [ :canvas | self renderContentOn: canvas ]! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 11:38'!
respondRendered

	^ self respondRenderedTo: self requestContext.! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 11:38'!
respondRenderedTo: aRequestContext
	
	self renderedContent
		ifNotNil: [:content | 
			aRequestContext respond: [:response |
				self class isBinary ifTrue: [response binary].
				response
					doNotCache;
					attachmentWithFileName: self fileName;  
					contentType: self class contentType;
					nextPutAll: content]]
		ifNil: [aRequestContext responseGenerator notFound; respond]! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:35'!
sheetName
	"Answer the value of sheetName"

	^ sheetName! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:35'!
sheetName: anObject
	"Set the value of sheetName"

	sheetName := anObject! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
splitLeft
	"Answer the value of splitLeft"

	^ splitLeft! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
splitLeft: anObject
	"Set the value of splitLeft"

	splitLeft := anObject! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
splitTop
	"Answer the value of splitTop"

	^ splitTop! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
splitTop: anObject
	"Set the value of splitTop"

	splitTop := anObject! !

!ShSpreadsheet methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 14:38'!
updateRoot: root  ! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
useHeader
	"Answer the value of useHeader"

	^ useHeader! !

!ShSpreadsheet methodsFor: 'accessing' stamp: 'topa 2/1/2012 10:50'!
useHeader: anObject
	"Set the value of useHeader"

	useHeader := anObject! !

MAVisitor subclass: #ShSpreadsheetWriter
	instanceVariableNames: 'sheet'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

ShSpreadsheetWriter subclass: #ShColumnCounter
	instanceVariableNames: 'count'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

!ShColumnCounter class methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 11:07'!
visit: aDescription

	^ self new
		visit: aDescription;
		count  ! !

!ShColumnCounter methodsFor: 'accessing' stamp: 'topa 2/1/2012 11:05'!
count
	"Answer the value of count"

	^ count! !

!ShColumnCounter methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 11:05'!
initialize 

	count := 0.! !

!ShColumnCounter methodsFor: 'accessing' stamp: 'topa 2/1/2012 11:05'!
visitElementDescription: aDescription

	count := count + 1.! !

ShSpreadsheetWriter subclass: #ShColumnWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

!ShColumnWriter class methodsFor: 'as yet unclassified' stamp: 'topa 2/1/2012 11:06'!
visit: aDescription! !

!ShColumnWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 11:12'!
visitElementDescription: aDescription

	| col |
	col := self sheet column
		caption: aDescription label;
		style: #header;
		yourself.
	(aDescription hasProperty: #spreadSheetWidth)
		ifTrue: [col width: aDescription spreadSheetWidth]! !

ShSpreadsheetWriter subclass: #ShFirstLineWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

!ShFirstLineWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 09:00'!
visitElementDescription: aDescription

	self sheet cell
		style: #header;
		with: [
		self sheet data: [
			self sheet text: aDescription label]]	.		! !

ShSpreadsheetWriter subclass: #ShSpreadsheetDataWriter
	instanceVariableNames: 'object'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Sheet-Magritte'!

!ShSpreadsheetDataWriter class methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 21:11'!
write: anObject description: aDescription to: aSheet
	^ self new write: anObject description: aDescription to: aSheet! !

!ShSpreadsheetDataWriter class methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 21:11'!
write: anObject to: aSheet

	^ self new write: anObject to: aSheet! !

!ShSpreadsheetDataWriter methodsFor: 'private' stamp: 'topa 2/1/2014 01:45'!
cellForDescription: aDescription
			
	^ 	self sheet cell style: aDescription spreadSheetStyle; yourself! !

!ShSpreadsheetDataWriter methodsFor: 'private' stamp: 'topa 2/1/2012 07:59'!
dataForDescription: aDescription

	^ ((aDescription hasProperty: #spreadSheetType)
			ifTrue: [	self sheet data type: aDescription spreadSheetType; yourself]
			ifFalse: [self sheet data]) ! !

!ShSpreadsheetDataWriter methodsFor: 'accessing' stamp: 'topa 1/31/2012 21:06'!
object
	"Answer the value of object"

	^ object! !

!ShSpreadsheetDataWriter methodsFor: 'accessing' stamp: 'topa 1/31/2012 21:06'!
object: anObject
	"Set the value of object"

	object := anObject! !

!ShSpreadsheetDataWriter methodsFor: 'private' stamp: 'topa 1/31/2012 21:07'!
object: anObject during: aBlock
	| previous |
	previous := self object. self object: anObject.
	aBlock ensure: [ self object: previous ]! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 09:59'!
visitBooleanDescription: aDescription

	self sheet cell
		beBoolean;
		with: [
		self sheet data
			beBoolean;
			with: [self sheet text: (self object 
				ifNotNil: [:o | o ifTrue: ['1'] ifFalse: ['0']]
				ifNil: [aDescription undefined])]].! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 1/31/2012 21:18'!
visitContainer: aDescription

	aDescription do: [ :each |
		self class
			write: (self object readUsing: each)
			description: each 
			to: self sheet]
			! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 09:03'!
visitElementDescription: aDescription

	(self cellForDescription: aDescription) with: [
		self object ifNotNil: [:o |
			(self dataForDescription: aDescription)  
				with: [self sheet text: o greaseString]]]! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 12:12'!
visitNumberDescription: aDescription

	(self cellForDescription: aDescription) with: [
		self object ifNotNil: [:o |
			(self dataForDescription: aDescription) 
				beNumber; 
				with: [self sheet text: 
					((o isInteger)
						ifTrue: [o greaseString]
						ifFalse: [o printShowingDecimalPlaces: 2])]]]! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2014 01:38'!
visitToOneRelationDescription: aDescription

	self visit: self object magritteDescription! !

!ShSpreadsheetDataWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2012 09:10'!
visitTokenDescription: aDescription

	(self cellForDescription: aDescription) with: [
		self object ifNotNil: [:o |
			(self dataForDescription: aDescription)  
				with: [o
					do: [ :each | self sheet text: each greaseString ]
					separatedBy: [ self sheet text: aDescription separators first ]]]].
	! !

!ShSpreadsheetDataWriter methodsFor: 'visiting' stamp: 'topa 1/31/2012 21:12'!
write: anObject description: aDescription to: aSheet

	self 
		sheet: aSheet;
		object: anObject;
		visit: aDescription.
! !

!ShSpreadsheetDataWriter methodsFor: 'visiting' stamp: 'topa 2/1/2014 01:38'!
write: anObject to: aSheet

	self write: anObject description: anObject magritteDescription to: aSheet.! !

!ShSpreadsheetWriter class methodsFor: 'as yet unclassified' stamp: 'topa 1/31/2012 20:04'!
visit: aDescription withSheet: sheet

	self new
		sheet: sheet;
		visit: aDescription.! !

!ShSpreadsheetWriter methodsFor: 'accessing' stamp: 'topa 1/31/2012 20:02'!
sheet
	"Answer the value of sheet"

	^ sheet! !

!ShSpreadsheetWriter methodsFor: 'accessing' stamp: 'topa 1/31/2012 20:02'!
sheet: anObject
	"Set the value of sheet"

	sheet := anObject! !

!ShSpreadsheetWriter methodsFor: 'visiting-description' stamp: 'topa 1/31/2012 20:11'!
visitContainer: aDescription

	self visitAll: aDescription children.! !

!ShSpreadsheetWriter methodsFor: 'visiting-description' stamp: 'topa 2/1/2014 01:38'!
visitRelationDescription: aDescription

	aDescription classes do: [:cls |
		self visit: cls magritteDescription].	! !
